package cmd

import (
	"github.com/spf13/cobra"
	"uauth/internal/client"
)

func initClient() *cobra.Command {
	return &cobra.Command{
		Use:   "client",
		Short: "Run the client",
		RunE: func(cmd *cobra.Command, args []string) error {
			return client.Run(cmd.Context())
		},
	}
}
